//30

unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids;

type
  TfrmMain = class(TForm)
    mapa: TImage;
    btnOpenMapa: TButton;
    OpenDialog: TOpenDialog;
    Label1: TLabel;
    memMapa: TMemo;
    Label2: TLabel;
    btnFind: TButton;
    SaveDialog: TSaveDialog;
    memTrasa: TMemo;
    strgPovely: TStringGrid;
    memCesta: TMemo;
    Button1: TButton;
    procedure btnOpenMapaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnFindClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    autox, autoy, lastx, lasty, vx, vy: integer; //aktalni pozice auta, minula pozice auta, aktualni rychlost
    startx, starty: integer; //start
    cilx1, cily1, cilx2, cily2: integer; //souradnice obdelniku
    map_sirka, map_vyska: integer; //sirka, vyska mapy
    map: array[1..255,1..255] of char; //mapa
    bmpMapa: TBitmap; //plocha ke kresleni mapy
    ctverec: integer; //strana ctverce pole v px
    kroku_bezp, kroku_nebezp: integer; //pocet kroku pri pouziti bezpecne cesty, pocet kroku pri pouziti nebezpecne cesty
    nalezena_cesta: boolean;
    procedure drawMap; //vykresli mapu podle pole map
    procedure drawCtverec(x, y: integer); //vykresli ctverec podle pole map a zadanych souradnic
    procedure drawCtverecCesta(x, y: integer); //vykresli ctverec cesty
    procedure findBezpCesta;
  end;

const
  //souradnice horizontalnich a vertikalnich sousednich poli (A=auto)
  {
  .1.
  4A2
  .3.
  }
  sx: array[1..4] of Shortint = (0,1,0,-1);
  sy: array[1..4] of Shortint = (1,0,-1,0);

  //souradnice diagonalnich sousednich poli (A=auto)
  {
  4.1
  .A.
  3.2
  }
  dx: array[1..4] of Shortint = (1,1,-1,-1);
  dy: array[1..4] of Shortint = (1,-1,-1,1);

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.drawCtverec; //nakresli ctverec
begin
  with bmpMapa.Canvas do begin
    with Brush do
      case map[x, y] of
        'S': Color:= clAqua;
        'C': Color:= clPurple;
        '.': Color:= clGreen;
        ':': Color:= clLime;
      end;
    if (map[x, y] <> 'X') then
      Rectangle((x-1)*ctverec,510-(y-1)*ctverec,x*ctverec+1,510-y*ctverec-1);
  end;
end;

procedure TfrmMain.drawCtverecCesta; //nakresli zluty ctverec cesty
begin
  with mapa.Canvas do begin
    Brush.Color:= clYellow;
    Pen.Style:= psClear;
    Rectangle((x-1)*ctverec,510-(y-1)*ctverec,x*ctverec+1,510-y*ctverec-1);
  end;
end;

procedure TfrmMain.drawMap; //vykresli mapu
var
  i, j: integer; //indexove  promenne
  vetsi_rozmer: integer; //vetsi rozmer mapy
begin
  with bmpMapa.Canvas do begin
    //pozadi = nepristupna pole
    Brush.Style:= bsSolid;
    Brush.Color:= clBlack;
    Pen.Style:= psClear;
    Rectangle(0,0,mapa.Width,mapa.Height);
    //velikost ctverce
    vetsi_rozmer:= map_sirka;
    if (map_vyska > vetsi_rozmer) then
      vetsi_rozmer:= map_vyska;
    ctverec:= (510 div vetsi_rozmer);
    //vykresleni mapy
    for j:= 1 to map_vyska do
      for i:= 1 to map_sirka do
        drawCtverec(i, j);
  end;
  mapa.Picture.Bitmap:= bmpMapa;
end;

procedure TfrmMain.btnOpenMapaClick(Sender: TObject); //nacte mapu
var
  i, j: integer; //indexove  promenne
  chyba: boolean;
begin
  chyba:= false;
  //nacteni mapy
  if OpenDialog.Execute then begin
    try
      Label1.Caption:= 'Mapa: '+OpenDialog.FileName;
      memMapa.Lines.LoadFromFile(OpenDialog.FileName);
      map_sirka:= length(memMapa.Lines[0]);
      map_vyska:= memMapa.Lines.Count;
      Label2.Caption:= IntToStr(map_sirka)+' x '+IntToStr(map_vyska);
      //nulovani promennych
      startx:= 0;
      starty:= 0;
      cilx1:= 0;
      cily1:= 0;
      cilx2:= 0;
      cily2:= 0;
      //nacteme mapu do pole
      for j:= 1 to map_vyska do begin
        if (Length(memMapa.Lines[map_vyska-j]) <> map_sirka) then
          chyba:= true;
        for i:= 1 to map_sirka do begin
          map[i, j]:= memMapa.Lines[map_vyska-j][i];
          if (map[i, j] = 'S') then begin
            startx:= i;
            starty:= j;
          end;
          if (map[i, j] = 'C') then begin
            if (cilx1 = 0) then begin
              cilx1:= i;
              cily1:= j;
              cilx2:= i;
              cily2:= j;
            end;
            if ((i - cilx2) = 1) then
              cilx2:= i;
            if ((j - cily2) = 1) then
              cily2:= j;
            //dva cile
            if ((i - cilx2) > 1) or ((j - cily2) > 1) then
              chyba:= true;
          end;
        end;
      end;
      if (startx = 0) or (cilx1 = 0) then //neni start nebo cil
        chyba:= true;
      //vykreslime
      if (not chyba) then
        drawMap;
    except
      ShowMessage('Chybne zadani mapy!');
    end;
    if (chyba) then
      ShowMessage('Chybne zadani mapy!');
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  bmpMapa:= TBitmap.Create;
  bmpMapa.Width:= 510;
  bmpMapa.Height:= 510;
  //
  strgPovely.Cells[0,0]:= 'Pozice';
  strgPovely.Cells[1,0]:= 'Povel';
  strgPovely.Cells[2,0]:= 'Popojede';
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  //uvolnime mapu
  bmpMapa.Free;
end;

procedure TfrmMain.findBezpCesta; //najde bezpecnou cestu (podle dvojtecek)

function vcili: boolean; //je uz auto v cili?
begin
  Result:= ((autox in [cilx1..cilx2]) and (autoy in [cily1..cily2]));
end;

function existsRovinka: integer; //existuje rovinka z mista kde se nachazi auto?
var
  i: integer;
  x, y: integer;
  existuje: integer;
begin
  existuje:= 0;
  for i:= 1 to 4 do begin //projdeme sousedni pole
    x:= autox+sx[i];
    y:= autoy+sy[i];
    if ((map[x,y] in [':','C']) and ((x <> lastx) or (y <> lasty))) then //nesmime jet zpet
      existuje:= i;
  end;
  Result:= existuje; // 0=neexistuje, 1-4=smer (viz const)
end;

function findZatacka: integer; //vrati smer zatacky
var
  i: integer;
  x, y: integer;
  smer: integer;
begin
  smer:= 0;
  for i:= 1 to 4 do begin //projdeme sousedni pole
    x:= autox+dx[i];
    y:= autoy+dy[i];
    if ((map[x,y] in [':','C']) and ((x <> lastx) or (y <> lasty))) then //nesmime jet zpet
      smer:= i;
  end;
  Result:= smer; // 0=neexistuje, 1-4=smer (viz const)
end;

function delkaRovinky(smer: integer): integer; //zjisti delku rovinky
var
  delka: integer;
  x, y: integer;
begin
  delka:= 0;
  x:= autox+sx[smer];
  y:= autoy+sy[smer];
  while (map[x,y] in [':','C']) do begin
    inc(delka);
    x:= x+sx[smer];
    y:= y+sy[smer];
  end;
  Result:= delka;
end;

procedure findRovinka(var delka_rovinky, smer_rovinky: integer); //najde smer a delku rovinky
begin
  smer_rovinky:= existsRovinka;
  if (smer_rovinky > 0) then
    delka_rovinky:= delkaRovinky(smer_rovinky)
  else
    delka_rovinky:= 0;
end;

procedure krok(zmenax, zmenay: integer); //ucini krok podle zadaneho povelu
begin
  Inc(kroku_bezp); //prictem kroky
  vx:= vx + zmenax;
  vy:= vy + zmenay;
  //zapiseme povely
  strgPovely.RowCount:= kroku_bezp+1;
  strgPovely.Cells[0, kroku_bezp]:= Format('%d,%d',[autox,autoy]);
  strgPovely.Cells[1, kroku_bezp]:= Format('%d,%d',[zmenax,zmenay]);
  strgPovely.Cells[2, kroku_bezp]:= Format('%d,%d',[vx,vy]);
  lastx:= autox;
  lasty:= autoy;
  autox:= autox + vx;
  autoy:= autoy + vy;
  //nakreslime cestu
  drawCtverecCesta(autox, autoy);
  if (vcili) then begin //jsme uz v cili?
    strgPovely.RowCount:= kroku_bezp+2;
    strgPovely.Cells[0, kroku_bezp+1]:= Format('%d,%d',[autox,autoy]);
    strgPovely.Cells[1, kroku_bezp+1]:= 'CIL';
    nalezena_cesta:= true;
  end;
end;

var
  delka_rovinky, smer_rovinky, max_rychlost, smer_zatacky: integer;
  konec_rovinkyx, konec_rovinkyy: integer;

begin
  //inicializace
  lastx:= 0;
  lasty:= 0;
  autox:= startx;
  autoy:= starty;
  vx:= 0;
  vy:= 0;
  memTrasa.Lines.Add(Format('startx=%d, starty=%d', [startx, starty]));
  repeat //dokud nedorazime do cile
    findRovinka(delka_rovinky, smer_rovinky); //zkusime najit rovinku
    max_rychlost:= trunc(sqrt(delka_rovinky)); //spocteme max rychlost tak, abychom na konci rovinky meli rychlost jedna a mohli v klidu zatacet (odvozeni ze souctu aritmeticke posloupnosti)
    memTrasa.Lines.Add(Format('delka=%d, smer=%d, maxv=%d', [delka_rovinky, smer_rovinky, max_rychlost]));
    if (delka_rovinky > 0) then begin //projeti rovinky
      konec_rovinkyx:= autox+sx[smer_rovinky]*delka_rovinky;
      konec_rovinkyy:= autoy+sy[smer_rovinky]*delka_rovinky;
      memTrasa.Lines.Add(Format('konecx=%d, konecy=%d', [konec_rovinkyx, konec_rovinkyy]));
      Application.ProcessMessages;
      //1.krok
      //po y-sour
      if (smer_rovinky in [1,3]) then begin
        krok(-vx, sy[smer_rovinky]-vy);
      end;
      //po x-sour
      if (smer_rovinky in [2,4]) then begin
        krok(sx[smer_rovinky]-vx, -vy);
      end;
      //zrychlovani
      while ((vx*sx[smer_rovinky]+vy*sy[smer_rovinky]) < max_rychlost) and (not nalezena_cesta) do begin
        krok(sx[smer_rovinky], sy[smer_rovinky]);
      end;
      //zpomalovani
      while ((vx*sx[smer_rovinky]+vy*sy[smer_rovinky]) > 1) and (not nalezena_cesta) do begin
        krok(sx[smer_rovinky]*(-1), sy[smer_rovinky]*(-1));
      end;
      //dojeti
      if ((not((autox = konec_rovinkyx) and (autoy = konec_rovinkyy))) and (not vcili)) then begin
        repeat
          krok(0,0);
        until (autox = konec_rovinkyx) and (autoy = konec_rovinkyy);
      end;
    end else begin //zatacka
      smer_zatacky:= findZatacka;
      Application.ProcessMessages;
      krok(dx[smer_zatacky]-vx,dy[smer_zatacky]-vy);
      //memTrasa.Lines.Add(IntToStr(smer_zatacky));
    end;

  until vcili;
end;

procedure TfrmMain.btnFindClick(Sender: TObject); //nalezne a ulozi cestu
var
  i: integer;
begin
  kroku_bezp:= 0;
  nalezena_cesta:= false;
  strgPovely.RowCount:= 2;
  mapa.Visible:= false;
  findBezpCesta;
  mapa.Visible:= true;
  if (SaveDialog.Execute) then begin //ulozime povely
    memCesta.Clear;
    for i:= 1 to kroku_bezp do
      memCesta.Lines.Add(strgPovely.Cells[1,i]);
    memCesta.Lines.SaveToFile(SaveDialog.FileName);
  end;
end;

procedure TfrmMain.Button1Click(Sender: TObject); //vykresli cestu ze zadane souboru do nactene mapy
var
  i: integer;
  vx, vy, zmenax, zmenay: integer;
  s: string;
begin
  if (OpenDialog.Execute) then begin
    memCesta.Lines.LoadFromFile(OpenDialog.FileName);
    autox:= startx;
    autoy:= starty;
    vx:= 0;
    vy:= 0;
    for i:= 0 to memCesta.Lines.Count-1 do begin //projdem vsechny povely
      s:= memCesta.Lines[i];
      s:= StringReplace(s, ',' , #13+#10, []);
      memTrasa.Text:= s;
      zmenax:= StrToInt(memTrasa.Lines[0]);
      zmenay:= StrToInt(memTrasa.Lines[1]);
      vx:= vx+zmenax;
      vy:= vy+zmenay;
      autox:= autox+vx;
      autoy:= autoy+vy;
      drawCtverecCesta(autox,autoy); //nakreslime policko trasy
    end;
  end;
end;

end.
